管道中失败的命令未触发“捕获”命令

时间:2019-08-08 00:45:49

标签: linux bash pipe conditional-execution

我正在尝试设置一小段代码,以便如果其中任何一段失败,它将触发另一行代码运行。就像这样:

cmd1 || cmd2

但是,第一段中有一个管道,所以:

cmd1 | cmd2 || cmd3

但是,如果cmd1失败,则cmd3不会运行。

如果尝试了以下操作,每次结果相同:

( cmd1 | cmd2 ) || cmd3
{ cmd1 | cmd2 } || { cmd3 }

为完整起见,这是我正在使用的特定代码块:

{
        {
            pkexec apt -y install (package-file-name) | zenity --progress --pulsate --auto-close --no-cancel --text="installing (package-name) . . ." 

        } && {
            notify-send "(package-name) has been installed"
        }
} || {
        zenity --error --text="Error code: $?"
}

到目前为止,它的运行就好像“ catch”语句(如果要调用它)甚至不存在一样。另外,它的第一部分,特别是在管道之前的部分是,如果失败,则不会引发错误。我对管道的第二部分没有任何问题,所以不确定它是否会表现出相同的行为。

谢谢!

3 个答案:

答案 0 :(得分:1)

( cmd1 | cmd2 ; exit ${PIPESTATUS[0]}) || cmd3

如果在子外壳程序()中运行这些命令没有问题,这应该对您有用。

答案 1 :(得分:1)

在bash中,您可以设置pipefail。例如:

$ cat a.sh
#!/bin/bash

false | true || echo executed 1
set -o pipefail
false | true || echo executed 2
$ ./a.sh
executed 2

答案 2 :(得分:0)

您可以使用进程替换来使zenity的退出状态不相关。

if pkexec apt -y install (package-file-name) > >(
     zenity --progress --pulsate --auto-close --no-cancel --text="installing (package-name) . . ."
   ); then 
    notify-send "(package-name) has been installed"
else
    zenity --error --text="Error code: $?"
fi

或者,您可以使用显式的命名管道来避免需要任何非标准的shell扩展。

mkfifo p
zenity --progress --pulsate --auto-close --no-cancel --text="installing (package-name) . . ." < p &

if pkexec apt -y install package-file-name > p; then
    notify-send "(package-name) has been installed"
else
    zenity --error --text="Error code: $?"
fi